/*
Copyright The KCP Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"

	v1alpha1 "github.com/kcp-dev/kcp/pkg/apis/apiresource/v1alpha1"
)

// FakeNegotiatedAPIResources implements NegotiatedAPIResourceInterface
type FakeNegotiatedAPIResources struct {
	Fake *FakeApiresourceV1alpha1
}

var negotiatedapiresourcesResource = schema.GroupVersionResource{Group: "apiresource.kcp.dev", Version: "v1alpha1", Resource: "negotiatedapiresources"}

var negotiatedapiresourcesKind = schema.GroupVersionKind{Group: "apiresource.kcp.dev", Version: "v1alpha1", Kind: "NegotiatedAPIResource"}

// Get takes name of the negotiatedAPIResource, and returns the corresponding negotiatedAPIResource object, and an error if there is any.
func (c *FakeNegotiatedAPIResources) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NegotiatedAPIResource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(negotiatedapiresourcesResource, name), &v1alpha1.NegotiatedAPIResource{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NegotiatedAPIResource), err
}

// List takes label and field selectors, and returns the list of NegotiatedAPIResources that match those selectors.
func (c *FakeNegotiatedAPIResources) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NegotiatedAPIResourceList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(negotiatedapiresourcesResource, negotiatedapiresourcesKind, opts), &v1alpha1.NegotiatedAPIResourceList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.NegotiatedAPIResourceList{ListMeta: obj.(*v1alpha1.NegotiatedAPIResourceList).ListMeta}
	for _, item := range obj.(*v1alpha1.NegotiatedAPIResourceList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested negotiatedAPIResources.
func (c *FakeNegotiatedAPIResources) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(negotiatedapiresourcesResource, opts))
}

// Create takes the representation of a negotiatedAPIResource and creates it.  Returns the server's representation of the negotiatedAPIResource, and an error, if there is any.
func (c *FakeNegotiatedAPIResources) Create(ctx context.Context, negotiatedAPIResource *v1alpha1.NegotiatedAPIResource, opts v1.CreateOptions) (result *v1alpha1.NegotiatedAPIResource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(negotiatedapiresourcesResource, negotiatedAPIResource), &v1alpha1.NegotiatedAPIResource{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NegotiatedAPIResource), err
}

// Update takes the representation of a negotiatedAPIResource and updates it. Returns the server's representation of the negotiatedAPIResource, and an error, if there is any.
func (c *FakeNegotiatedAPIResources) Update(ctx context.Context, negotiatedAPIResource *v1alpha1.NegotiatedAPIResource, opts v1.UpdateOptions) (result *v1alpha1.NegotiatedAPIResource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(negotiatedapiresourcesResource, negotiatedAPIResource), &v1alpha1.NegotiatedAPIResource{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NegotiatedAPIResource), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeNegotiatedAPIResources) UpdateStatus(ctx context.Context, negotiatedAPIResource *v1alpha1.NegotiatedAPIResource, opts v1.UpdateOptions) (*v1alpha1.NegotiatedAPIResource, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(negotiatedapiresourcesResource, "status", negotiatedAPIResource), &v1alpha1.NegotiatedAPIResource{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NegotiatedAPIResource), err
}

// Delete takes name of the negotiatedAPIResource and deletes it. Returns an error if one occurs.
func (c *FakeNegotiatedAPIResources) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(negotiatedapiresourcesResource, name, opts), &v1alpha1.NegotiatedAPIResource{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeNegotiatedAPIResources) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(negotiatedapiresourcesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.NegotiatedAPIResourceList{})
	return err
}

// Patch applies the patch and returns the patched negotiatedAPIResource.
func (c *FakeNegotiatedAPIResources) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NegotiatedAPIResource, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(negotiatedapiresourcesResource, name, pt, data, subresources...), &v1alpha1.NegotiatedAPIResource{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.NegotiatedAPIResource), err
}
